hdu1024 Max Sum Plus Plus (Dp)

hdu1024 Max Sum Plus Plus

Now I think you have got an AC in Ignatius.L‘s "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

Given a consecutive number sequence S 1, S 2, S 3, S 4 ... S x, ... S n (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ S x ≤ 32767). We define a function sum(i, j) = S i + ... + S j (1 ≤ i ≤ j ≤ n).

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i 1, j 1) + sum(i 2, j 2) + sum(i 3, j 3) + ... + sum(i m, j m) maximal (i x ≤ iy ≤ j x or i x ≤ j y ≤ j x is not allowed).

But I`m lazy, I don‘t want to write a special-judge module, so you don‘t have to output m pairs of i and j, just output the maximal summation of sum(i x, j x)(1 ≤ x ≤ m) instead. ^_^

Input

Each test case will begin with two integers m and n, followed by n integers S 1, S2, S 3 ... S n.

Process to the end of file.

Output

Output the maximal summation described above in one line.

Sample Input

1 3 1 2 3

2 6 -1 4 -2 3 -2 3

Sample Output

6

8

Hint

Huge input, scanf and dynamic programming is recommende

解题思路:

首先定义各个数组,尽量易懂,

a[i] 储存输入的数据

now[j],表示以第j个元素为结尾的i个子段的最大和,必须包含a[j]。

pre[j],表示前j个元素i个子段的最大和,不一定包含a[j]。

dp[i][j],表示前j个元素i个子段的最大和,包含a[j]。

原始状态转移方程:

dp[i][j]=max(dp[i][j-1]+a[j],dp[i-1][k]+a[j])         (i-1<=k<=j-1)

有两种情况:

1.直接将第j个元素加在第i个子段之后。

2.第j个元素单独作为一个子段,那么前面必须是i-1个子段。

状态转移方程就是比较这两种情况较大值

实现代码:

#include<iostream>
 #include<algorithm>
 #include<cstdio>
 #include<cstring>
 using namespace std;
 #define M 1000002
 int a[M],now[M],pre[M];
 int main()
 {
     int m,n,i,j,Max;
     while(scanf("%d%d",&m,&n)==2)
     {
         for(i=1;i<=n;i++)
             scanf("%d",&a[i]);
         memset(now,0,sizeof(now));
         memset(pre,0,sizeof(pre));
         for(i=1;i<=m;i++)
         {
             Max = -999999999;  //此处max值尽量开大,max是和,开小了就WA,
             for(j=i;j<=n;j++)
             {
                 now[j]=max(now[j-1]+a[j],pre[j-1]+a[j]);
                //now[j]有两种来源,一种是直接在第i个子段之后添加a[j]
                //一种是是a[j]单独成为1个子段
                 pre[j-1]=Max;       //更新pre使得pre是前j-1个中最大子段和
                 if(now[j]>Max)                   Max=now[j];
             }
         }
         printf("%d\n",Max);
     }
     return 0;
 }
时间: 2024-11-03 21:32:57

hdu1024 Max Sum Plus Plus (Dp)的相关文章

HDU 1024 Max Sum Plus Plus --- dp+滚动数组

HDU 1024 题目大意:给定m和n以及n个数,求n个数的m个连续子系列的最大值,要求子序列不想交. 解题思路:<1>动态规划,定义状态dp[i][j]表示序列前j个数的i段子序列的值,其中第i个子序列包括a[j], 则max(dp[m][k]),m<=k<=n 即为所求的结果 <2>初始状态: dp[i][0] = 0, dp[0][j] = 0; <3>状态转移: 决策:a[j]自己成为一个子段,还是接在前面一个子段的后面 方程: a[j]直接接在前面

HDU 1024 Max Sum Plus Plus (DP&#183;滚动数组)

题意  从n个数的数组中选出不相交的m段  求被选数的和的最大值 Max Sum 的升级版  不只是要选一段连续的了  而是选m段  思想还是类似  依旧dp 状态和状态转移方程不是很难想  在 Max Sum 这个问题中 dp[i] 表示的是以第i个数结尾的一段的 Max Sum  由于这里还有一个多少段的状态  于是这里令 dp[i][j] 表示在前 i 个数中选取 j 组  且第 i 个数在最后一组中的 Max Sum Plus Plus 那么现在对于第i个数有两种决策 1,  第 i 个

HDU 1024 Max Sum Plus Plus Dp题解

本题就是求m段子段,而且要求这些子段加起来和最大,最大子段和的Plus版本. 不过题意真的不好理解,x,y什么的都没有说清楚. 知道题意就开始解题了,这肯定是动态规划法了. 动态规划法的程序不难写,关键是抽象思维. 这里的最小情况是只分成一段的时候,就退化为最大子段和问题了,这个是段数的最小情况了: 如果只有0个数的时候,结果肯定为零了,或者如果只有一个数的时候就是这个数了,那么数列只有0个或者1个的时候就是数组的最小情况了. 然后记录使用一个数组记录dp[MAX_N],其中dp[i]的含义就是

HDU1024 Max Sum Plus Plus 【DP】

Max Sum Plus Plus Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 17164    Accepted Submission(s): 5651 Problem Description Now I think you have got an AC in Ignatius.L's "Max Sum" problem

HDU1024 Max Sum Plus Plus(dp)

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1024 1 #include<iostream> 2 #include<vector> 3 #include<algorithm> 4 #include<cmath> 5 #include<cstring> 6 #include<queue> 7 #include<cstdio> 8 #include<unordered_ma

Hdu 1024 Max Sum Plus Plus (dp)

题目链接: Hdu 1024 Max Sum Plus Plus 题目描述: 给出n个数,问m段连续子序列的和相加最大是多少? 解题思路: dp[i][j]表示把前i个元素(包括第i个),分成j段的最大和.状态转移方程就是dp[i][j] = max (dp[i-1][j] + arr[j],  max( dp[k][j-1]) + arr[j]),其中0<k<i.(第i个元素是保存在第j段,还是自己单独成段) 由于1<=n<=1000,000.n*n的数组肯定会爆炸,所以要对方程

Max Sum Plus Plus-HDU1024(dp)

Problem Description Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem. Given a consecutive number sequ

hdu 1024 Max Sum Plus Plus(DP&amp;最大连续和加强版)

Max Sum Plus Plus Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 16843    Accepted Submission(s): 5539 Problem Description Now I think you have got an AC in Ignatius.L's "Max Sum" problem

杭电1003(Max Sum) 首次dp

点击打开杭电1003 Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the inp